<?php
class FrontController {
	
	public $useQueryString = false;
	public $baseUrl = '';
	public $rootUrl = '/';
	public $viewPath = '';
	
	private function getControllerStatic($ctlname) {
		switch ($ctlname) {
			case 'user':
				return new UserController($this->viewPath);
			case 'document':
				return new DoucmentController($this->viewPath);
			case 'group':
				return new GroupController($this->viewPath);
			case 'index':
			case '':
				return new IndexController($this->viewPath);
			default:
				return new ErrorController($this->viewPath);
		}
	}
	
	private function getControllerDynamic($ctlname) {
		$controller_name = ucwords($ctlname ? $ctlname : 'index') . "Controller";
		if (class_exists($controller_name, true)) {
			return new $controller_name($this->viewPath);
		} else {
			return new ErrorContorller();
		}
	}
	
	private function getController($ctlname) {
		$ret = $this->getControllerDynamic($ctlname);
		$this->configureController($ret);
		return $ret;
	}
	
	private function CallAction($ctl, $actname, $data) {
		if ($actname == 'list' && method_exists($ctl, 'getlist')) {
			$actname = 'getlist';
		}
		call_user_func_array(array($ctl, $actname), $data);
	}
	
	private function splitUrl($url) {
		if (strpos($url, $this->baseUrl) === 0) {
			$url = substr($url, strlen($this->baseUrl));
		}
		$url = trim($url, '/');
		
		if ($this->useQueryString) {
			return array($_GET['c'], $_GET['a'], $_GET['d']);
		} else {
			$data = trim($url, '/');
			return explode('/', $url);
		}
	}
	
	protected function configureController($ctl) {
		$ctl->baseUrl = $this->baseUrl;
		$ctl->rootUrl = $this->rootUrl;
		$ctl->useQueryString = $this->useQueryString;
	}
	
	public function dispatch($url) {
		$urldata = $this->splitUrl($url);
		$ctl = $this->getController($urldata[0]);
		if ( ! is_a($ctl, 'UserController') &&
			 ! isset($_SESSION[Auth::CURR_USER]) ) {
			$ctl->redirect('/user/login/');
		} else {
			$this->CallAction($ctl, $urldata[1], array_slice($urldata, 2));
		}
	}
}