<?php
# TODO: Need to account for 
class User {
	const PW_HASH_LENGTH = 32;
	const AUTH_TOK_NAME = 'auth';
	const CURR_USER = "curr_user";
	
	public $username = '';
	public $password = '';
	
	private $db;
	
	public function __construct($datarow=null) {
		$this->db = new DB();
		if ($datarow) {
			$this->username = $datarow['username'];
			$this->password = $datarow['password'];
		}
	}
	
	public function SetPassword($pass) {
		$this->password = $this->hash($pass);
	}
	
	public function checkPassword($pass) {
		return $this->password == $this->hash($pass);
	}
	
	// Enforce that passwords cannot be empty.
	protected function hash($pass) {
		if (strlen($pass) == 0) {
			throw new Exception('Password too short');
		}
		return md5($pass);
	}
	
	public function GetGroups() {
		$members = $this->db->SelectGroupMembersByUser($this->username);
		$groups = array();
		foreach ($members as $member) {
			$groups[] = new Group($member);
		}
		return $groups;
	}
	
	public function isAdministrator() {
		return $this->db->SelectAdminMembershipByUser($this->username);
	}
	
	public function Insert() {
		$data = array('username'=> $this->username,
					  'password'=> $this->password);
		return $this->db->InsertUser($data);
	}
	
	public function Update() {
		$data = array('username'=> $this->username,
					  'password'=> $this->password);
		return $this->db->Updateuser($this->username, $data);
	}
	
	public function Save() {
		$user = $this->db->SelectUser($this->username);
		if ($user === null) {
			return $this->Insert();
		} else {
			return $this->Update();
		}
	}
	
	static public function GetByName($name) {
		$db = new DB();
		$row = $db->SelectUser($name);
		if ($row) {
			return new User($row);
		} else {
			return null;
		}
	}
	
	static public function GetAll() {
		$db = new DB();
		$rows = $db->SelectAllUsers();
		$ret = array();
		foreach ($rows as $row) {
			$ret[] = new User($row);
		}
		return $ret;
	}
}